--
-- Mod: Animals Hud
--
-- Author: Deekay
-- email: domkopp29@gmail.com
-- @Date: 17.12.2018
-- @Version: 0.0.0.1 BETA

animalsHUD = {};

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");

animalsChickenHudActive = false;
animalsCowHudActive = false;
animalsHorseHudActive = false;
animalsPigHudActive = false;
animalsSheepHudActive = false;

showDebug = false;

animalsHUD.version = getXMLString(modDesc, "modDesc.version");
animalsHUD.modDirectory = g_currentModDirectory;

addModEventListener(animalsHUD);

function animalsHUD:loadMap()

	print("############################################################");
	print("--- Animals HUD v.:" .. self.version .. ", by Deekay.");
	print("############################################################");

	end;

function animalsHUD:keyEvent(unicode, sym, modifier, isDown)
  
  	--SHOW HUD CHICKEN
	 if Input.isKeyPressed(Input.KEY_lctrl) and Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_u) then
		animalsChickenHudActive =not animalsChickenHudActive;
	end;
  	--SHOW HUD COW
	 if Input.isKeyPressed(Input.KEY_lctrl) and Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_i) then
		animalsCowHudActive =not animalsCowHudActive;
	end;
  	--SHOW HUD HORSE
	 if Input.isKeyPressed(Input.KEY_lctrl) and Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_j) then
		animalsHorseHudActive =not animalsHorseHudActive;
	end;
   	--SHOW HUD PIG
	 if Input.isKeyPressed(Input.KEY_lctrl) and Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_o) then
		animalsPigHudActive =not animalsPigHudActive;
	end;
  	--SHOW HUD SHEEP
	 if Input.isKeyPressed(Input.KEY_lctrl) and Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_t) then
		animalsSheepHudActive =not animalsSheepHudActive;
	end;
  
end;

function animalsHUD:mouseEvent(posX, posY, isDown, isUp, button)
end;

function animalsHUD:deleteMap()
end;

function animalsHUD:update(dt)

end;

function animalsHUD:draw()
  
  
           -- ID 28 = GRAS
           -- ID 24 = SILAGE 
           -- ID 30 = HEU
           -- ID 19 = MISCHRATION
           -- ID 18 = WASSER
           -- ID 31 = STROH
           -- ID 2 = WEIZEN
           -- ID 8 = MAIS
           -- ID 6 = SONNENBLUMEN
           -- ID 9 = KARTOFFEL
           -- ID 4 = HAFER

    
      -------------------------------------------------
      -- setting for screen render
      -------------------------------------------------
		 posX = 0.70; -- Data X position //  0.5 = center from screen
		 posX2 = posX + 0.1; -- Data offset X position
		 posY = 0.83; -- Data Y position // 0.5 = center from screen
		 linePadding = 0.003; -- Padding between blocks
		 fontSize = 0.011; -- Font size
		 paddingBetweenLines = fontSize + 0.004;  -- Distance between lines
		 setTextColor(1,1,1,1);
    
    
    
--    --check percent and set colors
--   function setColorIndicatorForMaxAndMinPercentValues(percent)
   
--     if percent >= 0.1 then
--       setTextColor(1,0,0,1); -- red
         
--      elseif percent >= 0.5 then
--        setTextColor(0,0,1,1); -- blue
        
--        elseif percent >= 0.8 then
--        setTextColor(0,1,0,1); -- green
--        end
--     end
   

    -------------------------------------------------
    -- draw the animals infos on the screen. 
    -------------------------------------------------
    function drawInfo(title, valueToDraw, valueForPadding)
   
    setTextColor(1,1,1,1);
    setTextBold(false);
    setTextAlignment(RenderText.ALIGN_LEFT);
    posY = posY - paddingBetweenLines;
    if title~=nil and valueToDraw ~=nil  then
      if valueForPadding == 0 then
    renderText(posX2, posY, fontSize, title .. " " .. tostring(valueToDraw)) -- first item
    end;
  if valueForPadding > 0  then
      renderText(posX2, posY, fontSize, title .. " " .. tostring(valueToDraw)) -- all other items
  end;
  else
   setTextColor(0,0,1,1); --blue
   renderText(posX2, posY, fontSize, "--")
    end
   end

   function drawAnimalMainHeader(mainAnimalName)
     
--     setTextColor(0,1,1,1);
--     setTextBold(true);
--     setTextAlignment(RenderText.ALIGN_LEFT);
--     local fontSizeHeader = 0.010
--     local fontPosXHeader = 0.85
--     local fontPosYHeader = 0.85
     
--      renderText(fontPosXHeader, fontPosYHeader, fontSizeHeader, ""); -- clear text
     
--      if mainAnimalName == "CHICKEN" then
--      renderText(fontPosXHeader, fontPosYHeader, fontSizeHeader, "Hüner");
--      end
--       if mainAnimalName == "COW" then
--      renderText(fontPosXHeader, fontPosYHeader, fontSizeHeader, "Kühe");
--      end
--      if mainAnimalName == "PIG" then
--       renderText(fontPosXHeader, fontPosYHeader, fontSizeHeader, "Schweine");
--      end
--      if mainAnimalName == "HORSE" then
--       renderText(fontPosXHeader, fontPosYHeader, fontSizeHeader, "Pferde");
--      end
--      if mainAnimalName == "SHEEP" then
--       renderText(fontPosXHeader, fontPosYHeader, fontSizeHeader, "Schafe");
--      end
     end
     
    -------------------------------------------------
    -- creates a padding freespace
    -------------------------------------------------
		function paddingTop()
			posY = posY - linePadding;
		end;
    
       function getFillLevelFoodFromId(id, husbandry)
         
          --loop for fillCapacity Food
           local capacities = husbandry.modulesByName.food.foodGroupCapacities
           local capacity = 0;
           for k,v in pairs(capacities) do  
             capacity = capacities[k].capacity;
           end

             local fillLevelFood = tonumber(math.ceil(husbandry.modulesByName.food.fillLevels[id]));
             local fillLevelFoodPercent = tonumber(math.ceil((100 * fillLevelFood / capacity)));
            return fillLevelFood .. " Liter / zu " .. fillLevelFoodPercent .. "% Voll";
          end
          
           function getFillLevelWaterFromId(id, husbandry)
             
             --loop for fillCapacity Water
            local capacity = husbandry.modulesByName.water.fillCapacity

             local fillLevelWater = tonumber(math.ceil(husbandry.modulesByName.water.fillLevels[id]));
             local fillLevelWaterPercent = tonumber(math.ceil((100 * fillLevelWater / capacity)));
            return fillLevelWater .. " Liter / zu " .. fillLevelWaterPercent .. "% Voll";
          end
          
          function getFillLevelStrawFromId(id, husbandry)
            
             --loop for fillCapacity Straw
             local capacity = husbandry.modulesByName.straw.fillCapacity
             
             local fillLevelStraw = tonumber(math.ceil(husbandry.modulesByName.straw.fillLevels[id]));
             local fillLevelStrawPercent = tonumber(math.ceil((100 * fillLevelStraw / capacity)));
            return fillLevelStraw .. " Liter / zu " .. fillLevelStrawPercent .. "% Voll";
          end
          
          function getCleanlinessFactorInPercent(husbandry)
            local cleanPercent = tonumber(math.ceil(husbandry.modulesByName.foodSpillage.cleanlinessFactor * 100)) --%
            return "" .. tostring(cleanPercent) .." %"
          end
          
          function countAnimals(husbandry)
            local numberOfAnimalsChicken = 0;
            for k,v in pairs(husbandry.modulesByName.animals.animals) do
          numberOfAnimalsChicken = tonumber(k)
        end
            return numberOfAnimalsChicken
          end 
          
	if animalsChickenHudActive == true then --CHICKEN
   for _,husbandry in pairs(g_currentMission.husbandries) do
			if husbandry.modulesByName.animals.animalType == "CHICKEN" then
        local numberOfAnimalsChicken = countAnimals(husbandry);
        local cleanliness = getCleanlinessFactorInPercent(husbandry);
         if numberOfAnimalsChicken > 0 then
          drawInfo("Hüner im Stall..:", numberOfAnimalsChicken .. "/ Sauberkeit: ".. cleanliness, tonumber(linePadding));  
          drawInfo("Weizen/Gerste...:", getFillLevelFoodFromId(2,husbandry), tonumber(linePadding));
          drawInfo("-KEY U----------------------------------------------------------------------","", tonumber(linePadding))
        else 
          drawInfo("Keine Tiere","", tonumber(linePadding))
          drawInfo("-KEY U----------------------------------------------------------------------","", tonumber(linePadding))
           end;
         end;
      paddingTop();
 end
end

if animalsCowHudActive == true then -- COW
      for _,husbandry in pairs(g_currentMission.husbandries) do
			if husbandry.modulesByName.animals.animalType == "COW" then
     local numberOfAnimalsCow = countAnimals(husbandry);
     local cleanliness = getCleanlinessFactorInPercent(husbandry);
         if numberOfAnimalsCow > 0 then
           drawInfo("Kühe im Stall..:", numberOfAnimalsCow .. "/ Sauberkeit: ".. cleanliness, tonumber(linePadding));  
           drawInfo("Wasser.........:", getFillLevelWaterFromId(18,husbandry) , tonumber(linePadding));
           drawInfo("Stroh..........:", getFillLevelStrawFromId(31,husbandry) , tonumber(linePadding));
           drawInfo("Gras...........:", getFillLevelFoodFromId(28,husbandry) , tonumber(linePadding));
           drawInfo("Mischration....:", getFillLevelFoodFromId(19,husbandry) , tonumber(linePadding));
           drawInfo("Heu / Silage...:", getFillLevelFoodFromId(24,husbandry) .. " / " .. getFillLevelFoodFromId(30, husbandry), tonumber(linePadding));
           drawInfo("-KEY I-----------------------------------------------------------------------","",tonumber(linePadding));
           else 
          drawInfo("Keine Tiere","", tonumber(linePadding))
          drawInfo("-KEY I----------------------------------------------------------------------","", tonumber(linePadding))
           end;
         end;
      paddingTop();
    end;
  end;
  
  if animalsPigHudActive == true then -- PIG
      for _,husbandry in pairs(g_currentMission.husbandries) do
			if husbandry.modulesByName.animals.animalType == "PIG" then
    
        local numberOfAnimalsPig = countAnimals(husbandry);
        local cleanliness = getCleanlinessFactorInPercent(husbandry);
         if numberOfAnimalsPig > 0 then
           drawInfo("Schweine im Stall..:", numberOfAnimalsPig .. "/ Sauberkeit: ".. cleanliness, tonumber(linePadding));   
           drawInfo("Wasser.............:", getFillLevelWaterFromId(18,husbandry),tonumber(linePadding));
           drawInfo("Stroh..............:", getFillLevelStrawFromId(31,husbandry),tonumber(linePadding));
           drawInfo("Mais...............:", getFillLevelFoodFromId(8,husbandry),tonumber(linePadding));
           drawInfo("Weizen/Gerste......:", getFillLevelFoodFromId(2,husbandry),tonumber(linePadding));
           drawInfo("Soja/Raps/Sonnen...:",getFillLevelFoodFromId(6,husbandry),tonumber(linePadding));
           drawInfo("Kartoffel/Rüben....:", getFillLevelFoodFromId(9,husbandry),tonumber(linePadding));
           drawInfo("-KEY O-----------------------------------------------------------------------","",tonumber(linePadding));
           else 
          drawInfo("Keine Tiere","", tonumber(linePadding))
          drawInfo("-KEY O----------------------------------------------------------------------","", tonumber(linePadding))
           end;
         end;
      paddingTop();
    end;
  end;
   if animalsHorseHudActive == true then -- HORSE
      for _,husbandry in pairs(g_currentMission.husbandries) do
			if husbandry.modulesByName.animals.animalType == "HORSE" then
      local numberOfAnimalsHorse = countAnimals(husbandry);

         if numberOfAnimalsHorse > 0 then

           drawInfo("Pferde im Stall..:", numberOfAnimalsHorse, tonumber(linePadding));     
           drawInfo("Wasser...........:", getFillLevelWaterFromId(18,husbandry),tonumber(linePadding));
           drawInfo("Stroh............:", getFillLevelStrawFromId(31,husbandry),tonumber(linePadding));
           drawInfo("Hafer............:", getFillLevelFoodFromId(30,husbandry),tonumber(linePadding));
           drawInfo("Heu..............:", getFillLevelFoodFromId(4,husbandry),tonumber(linePadding));
           drawInfo("-KEY J-----------------------------------------------------------------------","",tonumber(linePadding));
           else 
          drawInfo("Keine Tiere","", tonumber(linePadding))
          drawInfo("-KEY J----------------------------------------------------------------------","", tonumber(linePadding))
           end;
         end;
      paddingTop();
    end;
  end;
    if animalsSheepHudActive == true then -- SHEEP
      for _,husbandry in pairs(g_currentMission.husbandries) do

			if husbandry.modulesByName.animals.animalType == "SHEEP" then
         local numberOfAnimalsSheep = countAnimals(husbandry);
        local cleanliness = getCleanlinessFactorInPercent(husbandry);
    
      
         if numberOfAnimalsSheep > 0 then

           drawInfo("Schafe im Stall..:", numberOfAnimalsSheep .. "/ Sauberkeit: ".. cleanliness, tonumber(linePadding));     
           drawInfo("Wasser...........:", getFillLevelWaterFromId(18,husbandry),tonumber(linePadding));
           drawInfo("Gras / Heu.......:", getFillLevelFoodFromId(28, husbandry),tonumber(linePadding));
           drawInfo("-KEY T-----------------------------------------------------------------------","",tonumber(linePadding));
           else 
          drawInfo("Keine Tiere","", tonumber(linePadding))
          drawInfo("-KEY T----------------------------------------------------------------------","", tonumber(linePadding))
           end;
         end;
      paddingTop();
    end;
  end;
        setTextColor(1,1,1,1);
       renderText(posX2, posY - 0.003, 0.008, "Open Hud: ctrl + alt + (t,j,u,i,o) by Deekay Beta V:" .. self.version)
end;

